dist-upgrader tarball contains and uses an ancient version of invoke-rc.d

Bug #1813464 reported by despres laurent on 2019-01-27
8
This bug affects 1 person
Affects Status Importance Assigned to Milestone
cyrus-sasl2 (Ubuntu)
High
Unassigned
Disco
High
Unassigned
ubuntu-release-upgrader (Ubuntu)
Critical
Brian Murray
Disco
Critical
Brian Murray

Bug Description

I know that's not a good thing, but i try to upgrade versions by sSh

ProblemType: Package
DistroRelease: Ubuntu 19.04
Package: sasl2-bin 2.1.27+dfsg-1
ProcVersionSignature: Ubuntu 4.18.0-13.14-generic 4.18.17
Uname: Linux 4.18.0-13-generic x86_64
ApportVersion: 2.20.10-0ubuntu19
Architecture: amd64
Date: Sun Jan 27 09:34:34 2019
ErrorMessage: installed sasl2-bin package post-installation script subprocess returned error exit status 1
Python3Details: /usr/bin/python3.7, Python 3.7.2rc1, python3-minimal, 3.7.1-1ubuntu1
PythonDetails: /usr/bin/python2.7, Python 2.7.15+, python-minimal, 2.7.15-3
RelatedPackageVersions:
 dpkg 1.19.2ubuntu2
 apt 1.8.0~beta1
SourcePackage: cyrus-sasl2
Title: package sasl2-bin 2.1.27+dfsg-1 failed to install/upgrade: installed sasl2-bin package post-installation script subprocess returned error exit status 1
UpgradeStatus: Upgraded to disco on 2019-01-27 (0 days ago)
mtime.conffile..etc.default.saslauthd: 2019-01-14T05:57:07.197338

Related branches

despres laurent (lotik) wrote :
Robie Basak (racb) wrote :

From log:

Paramétrage de sasl2-bin (2.1.27+dfsg-1) ...
invoke-rc.d: syntax error: unknown option "--skip-systemd-native"
dpkg: erreur de traitement du paquet sasl2-bin (--configure) :
 installed sasl2-bin package post-installation script subprocess returned error exit status 1

Additionally it looks like /etc/default/saslauthd has a local modification.

Robie Basak (racb) wrote :

Thank you for taking the time to report this bug and helping to make Ubuntu better.

Since it seems likely to me that this is a local configuration problem, rather than a bug in Ubuntu, I'm marking this bug as Incomplete.

If indeed this is a local configuration problem, you can find pointers to get help for this sort of problem here: http://www.ubuntu.com/support/community

Or if you believe that this is really a bug, then you may find it helpful to read "How to report bugs effectively" http://www.chiark.greenend.org.uk/~sgtatham/bugs.html. We'd be grateful if you would then provide a more complete description of the problem, explain why you believe this is a bug in Ubuntu rather than a problem specific to your system, and then change the bug status back to New.

Changed in cyrus-sasl2 (Ubuntu):
status: New → Incomplete

First, sorry for my english,

I was scary, but there is no problem.

I have reboot the PC and after one upgarde has repaired the problem.

Thanks

Le 28/01/2019 à 19:46, Robie Basak a écrit :
> Thank you for taking the time to report this bug and helping to make Ubuntu better.
>
> Since it seems likely to me that this is a local configuration problem, rather than a bug in Ubuntu, I'm marking this bug as Incomplete.
>
> If indeed this is a local configuration problem, you can find pointers
> to get help for this sort of problem here:
> http://www.ubuntu.com/support/community
>
> Or if you believe that this is really a bug, then you may find it
> helpful to read "How to report bugs effectively"
> http://www.chiark.greenend.org.uk/~sgtatham/bugs.html. We'd be grateful
> if you would then provide a more complete description of the problem,
> explain why you believe this is a bug in Ubuntu rather than a problem
> specific to your system, and then change the bug status back to New.
>
>
> ** Changed in: cyrus-sasl2 (Ubuntu)
> Status: New => Incomplete
>

[Expired for cyrus-sasl2 (Ubuntu) because there has been no activity for 60 days.]

Changed in cyrus-sasl2 (Ubuntu):
status: Incomplete → Expired
Steve Langasek (vorlon) wrote :

I just reproduced this bug on an upgrade from cosmic to disco. Apparently sasl2-bin is using a new option to invoke-rc.d which is not supported in the cosmic version of init-system-helpers, but does not have an appropriate versioned dependency on whichever version introduces this new flag.

This is reproducible with the stock Ubuntu packages and the original report of 'third-party-packages' is a false positive.

Changed in cyrus-sasl2 (Ubuntu):
importance: Undecided → High
status: Expired → Triaged
Steve Langasek (vorlon) wrote :

But also, init-system-helpers was already upgraded to the disco version when this happened (both for me, and for the original reporter) so I don't know why invoke-rc.d doesn't recognize this option given that it appears to be present in /usr/sbin/invoke-rc.d in disco.

Changed in init-system-helpers (Ubuntu Disco):
importance: Undecided → High
affects: init-system-helpers (Ubuntu Disco) → ubuntu-release-upgrader (Ubuntu Disco)
Steve Langasek (vorlon) wrote :

not a bug in init-system-helpers or cyrus2-sasl, but in ubuntu-release-upgrader, which has a local version of invoke-rc.d (DistUpgrade/imported/invoke-rc.d) that it puts on its path. I don't know why it does that, but it's clearly not up to date with disco.

Changed in ubuntu-release-upgrader (Ubuntu Disco):
status: New → Triaged
importance: High → Critical
tags: added: id-5cafae0c49e86133b50942bc
Changed in ubuntu-release-upgrader (Ubuntu Disco):
assignee: nobody → Brian Murray (brian-murray)
summary: - package sasl2-bin 2.1.27+dfsg-1 failed to install/upgrade: installed
- sasl2-bin package post-installation script subprocess returned error
- exit status 1
+ dist-upgrader tarball contains and uses an ancient version of invoke-
+ rc.d
Brian Murray (brian-murray) wrote :

The dist-upgrader tarball contains a copy of invoke-rc.d which it patches so that errors are not fatal and the release upgrade can proceed. Here's part of the patch as an example:

  1 --- /usr/sbin/invoke-rc.d 2018-11-21 15:15:24.000000000 -0800
  2 +++ DistUpgrade/imported/invoke-rc.d 2019-04-12 09:48:59.230957528 -0700
  3 @@ -346,6 +346,10 @@ verifyrclink () {
  4 shift
  5 done
  6 if test x${doexit} != x && test x${RETRY} = x; then
  7 + if [ -n "$RELEASE_UPGRADE_IN_PROGRESS" ]; then
  8 + printerror "release upgrade in progress, error is not fatal"
  9 + exit 0
 10 + fi
 11 exit ${doexit}
 12 fi
 13 return 0

The failure in this bug can be tested quickly in a chroot by installing the packages sasl2-bin and ubuntu-release-upgrader-core.

Steve Langasek (vorlon) on 2019-04-12
Changed in cyrus-sasl2 (Ubuntu Disco):
status: Triaged → Invalid
Changed in ubuntu-release-upgrader (Ubuntu Disco):
status: Triaged → Fix Committed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package ubuntu-release-upgrader - 1:19.04.16

---------------
ubuntu-release-upgrader (1:19.04.16) disco; urgency=medium

  * DistUpgrade/imported/invoke-rc.d: Import the current version of the script
    to fix upgrade failures of packages which only ship upstart and
    systemd units, but no SysV init script. (LP: #1813464)
  * DistUpgrade/imported/invoke-rc.d.diff: update the diff so that it applies
    to the current version of invoke-rc.d.
  * pre-build.sh: actually update invoke-rc.d on a regular basis and try to
    automatically appply the patch.
  * Update of demotions and mirrors data.

 -- Brian Murray <email address hidden> Fri, 12 Apr 2019 10:39:09 -0700

Changed in ubuntu-release-upgrader (Ubuntu Disco):
status: Fix Committed → Fix Released
Brian Murray (brian-murray) wrote :

I tested this with the latest version of the dist-upgrader and it worked without issue.

Brian Murray (brian-murray) wrote :

For the record I did a search of all the packages in the Ubuntu archive (for Bionic, Cosmic, and Disco) which used the new invoke-rc.d argument of "--skip-systemd-native" and only found sasl2-bin. Additionally, I also search all my local bug attachments (foundations-bugs subscribed packages) for issues with invoke-rc.d and didn't find any. Subsequently, I don't think this really needs SRU'ing for Bionic and Cosmic.

 $ export UST="/home/bdmurray/source-trees/ubuntu-security-tools"; export ARCH=amd64; for comp in main; do ~/source-trees/ubuntu-security-tools/repo-tools/for-archive /mnt/storage/archive-mirror/dists/disco/$comp/binary-$ARCH/Packages.gz /mnt/storage/archive-mirror/ $UST/repo-tools/for-archive-tools/unpack-control-search "skip-systemd-native"; done
/mnt/storage/archive-mirror/pool/main/c/cyrus-sasl2/sasl2-bin_2.1.27+dfsg-1_amd64.deb
 ./postinst: invoke-rc.d --skip-systemd-native saslauthd $_dh_action || exit 1
 ./prerm: invoke-rc.d --skip-systemd-native saslauthd stop || exit 1
[ 2:53PM 5093 ] [ bdmurray@bizarro:/mnt/storage/archive-mirror ]
 $ export UST="/home/bdmurray/source-trees/ubuntu-security-tools"; export ARCH=amd64; for comp in main; do ~/source-trees/ubuntu-security-tools/repo-tools/for-archive /mnt/storage/archive-mirror/dists/cosmic/$comp/binary-$ARCH/Packages.gz /mnt/storage/archive-mirror/ $UST/repo-tools/for-archive-tools/unpack-control-search "skip-systemd-native"; done
[ 3:00PM 5094 ] [ bdmurray@bizarro:/mnt/storage/archive-mirror ]
 $ export UST="/home/bdmurray/source-trees/ubuntu-security-tools"; export ARCH=amd64; for comp in universe multiverse restricted; do ~/source-trees/ubuntu-security-tools/repo-tools/for-archive /mnt/storage/archive-mirror/dists/cosmic/$comp/binary-$ARCH/Packages.gz /mnt/storage/archive-mirror/ $UST/repo-tools/for-archive-tools/unpack-control-search "skip-systemd-native"; done
[ 3:16PM 5095 ] [ bdmurray@bizarro:/mnt/storage/archive-mirror ]
 $ export UST="/home/bdmurray/source-trees/ubuntu-security-tools"; export ARCH=amd64; for comp in main universe multiverse restricted; do ~/source-trees/ubuntu-security-tools/repo-tools/for-archive /mnt/storage/archive-mirror/dists/bionic/$comp/binary-$ARCH/Packages.gz /mnt/storage/archive-mirror/ $UST/repo-tools/for-archive-tools/unpack-control-search "skip-systemd-native"; done

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers